#!/usr/bin/perl
# ȉ͕ύXKvȂ
#-----------------------------------------------------------------------------
#
# csv2srs (version  $Id: eodv,v 1.4 2007/05/22 02:22:33 fukuda Exp $) 
#
# SRS̎Zo
# 
# Usage:
# > csv2srs.pl hogehoge.csv 
#
# options:
#         ɖ
#
# example:
# csv2srs.pl hogehoge.csv                                #(1)
#
#-----------------------------------------------------------------------------
# Libraries
my @dt, @dg, @alpa, @beta, @A, @B, @C, @D, @yy;  
my $tt,$bs,$bb,$ymax;

$Q		= 10;
$PI		= 3.1415926;
$g 		= 9.80665;		# [m/s2]
$delt	= 0;			# dt
$zi		= 1/(2*$Q);
$wn		= 0.0;
$fbgn	= 1;			# [Hz]
$fmax	= 10000;		# [Hz]
$df		= 0;			# [Hz]
$i 		= 0;
$cnt 	= 0;
$k 		= 0;
$m		= 1;
$c		= 1;
$oct	= 100;
$aa		= 0;

#-----------------------------------------------------------------------------
# Code begin
#-----------------------------------------------------------------------------
($opt) = @ARGV;

if ($opt eq "-h") {
    &show_usage();
    exit;
}

# IvVȂꍇ
if ($#ARGV == -1){
	print "Error:t@Cw肵Ă\n";
}
# IvVPꍇ
if ($#ARGV == 0){
	
	# Ώۃt@C̃I[v
	open(IN,"<$ARGV[0]") || die "Error: can't open $ARGV[0]\n";
		@line = <IN>;
	close(IN);
	
	# SRSZo
	$cnt = -1;
	foreach (@line){
		# wb_΂
		if ($cnt == -1){
			$cnt++; 
			$Q = (split(/\,/,$_))[2];	if($Q == ""){$Q = 10;}
			$fmax = (split(/\,/,$_))[3];if($fmax == ""){$fmax	= 10000;}
			next;
		}
		# [sec]^x擾[m/s2]
		$dt[$cnt+1] = (split(/\,/,$_))[0];
		$dg[$cnt+1] = (split(/\,/,$_))[1];
		if ($cnt == 2)
		{
			# ԍ[sec]
			$delt = $dt[2]-$dt[1];
		}
		
		# CNg
		$cnt++;
	}

	# t@Co
	$ARGV[0] =~ s/.csv/_SRS.csv/g;
	open(OUT,">$ARGV[0]") || die "Error: can't make $PATH\n";
	
	# wb_o
	$disp = sprintf("f[Hz],G[g],Q=%f\n",$Q);
	print OUT $disp;
	
	$aa = &log10(($fmax))/$oct;
	for($j=$fbgn;$j<=$oct;$j++)
	{
		# vZ
		$wn   = 2*$PI*(10**($j*$aa));
		$ymax = &cal_acc();
			
		# ʏo
		$disp = sprintf("%f,%e\n",$wn/(2*$PI),$ymax);
		print OUT $disp;
		
		$pro = sprintf("%3.1f[\%]\n",$j/$oct*100);
		if($j%10==0){print $pro;}
	}
	close(OUT);	
}

sub cal_acc()
{
	# 
	$C[0] = $D[0] = $ymax = 0;
	
	for($i=1;$i<$cnt;$i++)
	{
		# xvZ
		#$A[$i] = $B[$i] = $C[$i] = 0;
	
		# ,vZEO
		$alpa[$i] = (($dg[$i+1] - $dg[$i])/($delt))*$g;
		$beta[$i] = (($dg[$i]*$dt[$i+1] - $dg[$i+1]*$dt[$i])/($delt))*$g;
			
		# vZ
		$C[$i] = -$alpa[$i]/($wn*$wn);
		$D[$i] = -$beta[$i]/($wn*$wn) + 2*$zi*$alpa[$i]/($wn*$wn*$wn);

		# ʉvZ
		$tt = $dt[$i];
		$bs =  &fd($tt)*(&fM($i-1,$tt)-&fM($i,$tt))-&fb($tt)*($C[$i-1] - $C[$i]);
		$bb = &fa($tt)*&fd($tt)-&fb($tt)*&fc($tt);
		$A[$i] = $bs/$bb/exp(-$zi*$wn*$tt) + $A[$i-1];

		$bs = -&fc($tt)*(&fM($i-1,$tt)-&fM($i,$tt))+&fa($tt)*($C[$i-1] - $C[$i]);
		$B[$i] = $bs/$bb/exp(-$zi*$wn*$tt) + $B[$i-1];

		# yyo
		$yy[$i] = -(&fM($i,$tt)+($A[$i]*&fa($tt) + $B[$i]*&fb($tt))*exp(-$zi*$wn*$tt))*$wn*$wn/$g;
		
		# ymax̎Zo
		if(abs($yy[$i]) > $ymax){$ymax = abs($yy[$i]);}
	}

	return $ymax;
}

# IvVQꍇ
if ($#ARGV == 1){	
}
exit;

#-----------------------------------------------------------------------------
# Sub code begin
#-----------------------------------------------------------------------------
sub fM()
{
		return $C[$_[0]]*$_[1] + $D[$_[0]];
}
sub fa()
{
	if($_[0] == 0){
		return 1;
	}else{
		#return exp(-$zi*$wn*$_[0])*cos(sqrt(1-$zi*$zi)*$wn*$_[0]);
		return cos(sqrt(1-$zi*$zi)*$wn*$_[0]);		
	}
}
sub fb()
{
	if($_[0] == 0){
		return 0;
	}else{
		#return exp(-$zi*$wn*$_[0])*sin(sqrt(1-$zi*$zi)*$wn*$_[0]);
		return sin(sqrt(1-$zi*$zi)*$wn*$_[0]);		
	}
}
sub fc()
{
	#return $wn*exp(-$zi*$wn*$_[0])*(-$zi*cos(sqrt(1-$zi*$zi)*$wn*$_[0])-sqrt(1-$zi*$zi)*sin(sqrt(1-$zi*$zi)*$wn*$_[0]));
	return $wn*(-$zi*cos(sqrt(1-$zi*$zi)*$wn*$_[0])-sqrt(1-$zi*$zi)*sin(sqrt(1-$zi*$zi)*$wn*$_[0]));
}
sub fd()
{
	#return $wn*exp(-$zi*$wn*$_[0])*(-$zi*sin(sqrt(1-$zi*$zi)*$wn*$_[0])+sqrt(1-$zi*$zi)*cos(sqrt(1-$zi*$zi)*$wn*$_[0]));
	return $wn*(-$zi*sin(sqrt(1-$zi*$zi)*$wn*$_[0])+sqrt(1-$zi*$zi)*cos(sqrt(1-$zi*$zi)*$wn*$_[0]));	
}
sub log10 {
    my $n = shift;
    return log($n)/log(10);
}
sub show_usage()
{
  print "EoDV(dd)𒊏oE\n";
  print "\n";
  print "Usage:\n";
  print "> eodv [-h]\n";
  print "\n";
  print "options:\n";
  print "         -h : p@񎦂\n";
  print "      -make : Level-2XV\n";
  print "\n";
  print "example:\n";
  print "eodv -h                         #(1) HELP\n";
}


